;______  ____ _  __________________  ___  _____   
;[__ ||\/||__]|  ||__/| __|___|__/|_/ ||\ || __  
;___]||  ||__]|__||  \|__]|___|  \| \_|| \||__]   
;
;
; _                                                     
;/  _  _| _   |_       | _  _ |_     _.  \    /o _  _   
;\_(_)(_|(/_  |_)\/  \_|(_)_> | ||_|(_|   \/\/ |_> (/_  
;                /                                      
; __  _      __                      _                                 
;/__ |_ \/ /(_  _    ._  _|  |_     |_) _.._  _| _ ._ _  _ ._ o    _   
;\_| |  /\/ __)(_)|_|| |(_|  |_)\/  |  (_|| |(_|(/_| | |(_)| |||_|_>   
;                               /                                      


                               
;__  ______   _  ____ ________    ___________    
;||\ ||   |   |  ||  \|___[__     |___ | |       
;|| \||___|___|__||__/|______].   |___ | |___.   
;                             '                                                                                                    

AddMacro: MACRO
	push bc
	push af
	ld a,\1
	ld c,a
	ld b,0
	ld hl,\2
	add hl,bc
	pop af
	pop bc
endm

	;INCLUDE "gbhw.inc"
        INCLUDE "hardware.inc"
        rev_Check_hardware_inc 1.5
        INCLUDE "defines.inc"
DELAY_VALUE	equ	$04
include "player.inc"    ; the music player header file
SECTION "Info",HOME[$00]
DB "SimBurgerKing by Joshua Wise. Binary Version Alpha 2."
SECTION "V Blank",HOME[$40]

	call		vbl
	reti
    
        SECTION "Org $100",HOME[$100]

        nop
        jp      begin

        ;       
        ;                                                              "123456789ABCDEF"
        ROM_HEADER      3, 2, 1,  "Cook on GBColor"


		INCLUDE "ingametiledta.inc"
		INCLUDE "ingamemap.inc"
		INCLUDE "IncorrectMap.inc"
		INCLUDE "CorrectMap.inc"
		
        INCLUDE "memory.asm"
        
		GLOBAL pad_Read

AmountofTime		EQU 20
TimePerSecond		EQU 65

TilePals:
DW InGameTileDataCGBPal0c0, InGameTileDataCGBPal0c1, InGameTileDataCGBPal0c2, InGameTileDataCGBPal0c3
DW InGameTileDataCGBPal1c0, InGameTileDataCGBPal1c1, InGameTileDataCGBPal1c2, InGameTileDataCGBPal1c3
DW InGameTileDataCGBPal2c0, InGameTileDataCGBPal2c1, InGameTileDataCGBPal2c2, InGameTileDataCGBPal2c3
DW InGameTileDataCGBPal3c0, InGameTileDataCGBPal3c1, InGameTileDataCGBPal3c2, InGameTileDataCGBPal3c3
DW InGameTileDataCGBPal4c0, InGameTileDataCGBPal4c1, InGameTileDataCGBPal4c2, InGameTileDataCGBPal4c3
DW InGameTileDataCGBPal5c0, InGameTileDataCGBPal5c1, InGameTileDataCGBPal5c2, InGameTileDataCGBPal5c3
DW InGameTileDataCGBPal6c0, InGameTileDataCGBPal6c1, InGameTileDataCGBPal6c2, InGameTileDataCGBPal6c3


; _  _______  _   ___ ____________   
; |\/||__|||\ |   |__]|__/|  ||      
; |  ||  ||| \|   |   |  \|__||___   
;       
                           

begin:


        di


		and		a   				; 1:DMG , FF:MGB , 11:CGB
		cp		$11
		ld		a,0   				; Not CGB(0) (XOR A impossible since Zero-Flag changes)
		jr		NZ,init_NotColor
		inc		a   				; We have a Color Gameboy
		
init_NotColor:
		ld		[CGBFlag],a	
		
		

		
		call	LoadVars
		call	ENABLE_RAM_MBC1
		

		
		call	HI_Init
afterthestart:		
		di
		ld      sp,$ffff
        call    StopLCD
        
		ld 		a,1
		call 	SWITCH_ROM_MBC1
		
        ld      hl,music        ; load music address to hl
        xor     a               ; load beginning pattern pos to a (0)
        ld      b,a             ; load restart pattern pos to b (0)
        call    MBInit          ; initialize the music
        
        xor a
        ld      [rSCX],a
        ld      [rSCY],a
        
		ld		a,2
		call	SWITCH_ROM_MBC1
		
        ld 		a,$00
        ld		[$FF4F],a
        
        ld      hl,InGameTileData
        ld      de,$8000
        ld      bc,8*256        ; length (8 bytes per tile) x (256 tiles)
        call    mem_Copy	    ; Copy tile data to memory
		
		ld 		a,$01
        ld		[$FF4F],a
        
        ld      hl,DefaultMapPLN1;Draw title
        ld      de,$9800
        ld      bc,20*32
        call    mem_Copy
        
        ld 		a,$00
        ld		[$FF4F],a

        ld      hl,DefaultMapPLN0;Draw title
        ld      de,$9800
        ld      bc,20*32
        call    mem_Copy        
        
        ld		a,3
		call	SWITCH_ROM_MBC1
        
        ld      hl,TilePals
        call    SetAllCGB_BGP
        
        ld		a,1
		call	SWITCH_ROM_MBC1

		ld a,200
        ld [rWX],a
        ld [rWY],a
		
        xor		a
        ld      a,LCDCF_ON|LCDCF_BG8000|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ16|LCDCF_OBJOFF|LCDCF_WINON
		or %01000000
		and %11110111
        ld      [rLCDC],a       ; Turn screen on

		ld 		a,0
		ld 		[_CurHead],a
		ld		[_CurBody],a
		ld		[_CurOrder],a
		ld		[_CurCustomer],a
		
		ld 		a,AmountofTime
		ld		[_TimeRemaining],a
		ld		[_CustRemaining],a
	
		
		ld 		a,0
		ld		[_Timer],a	
		
.gameloop:
		call 	UpdateTimeRemaining
		ld 		a,1
		call 	SWITCH_ROM_MBC1
		call    MBPlay          ; update the music in every frame at
                                        ; the same raster position
		call 	joypad
        jp      .gameloop

.you_shouldnt_be_here:
		jp begin
		ret
		
		
;save ram funcs		


LoadVars:
	ld   a,$0a
	ld   [0],a    ; Enable Cart Save RAM

	ld a,[$a000]
	cp "S"
	jp nz,.raminit
	ld a,[$a001]
	cp "B"
	jp nz,.raminit
	ld a,[$a002]
	cp "K"
	jp nz,.raminit
	jp .skipraminit
.raminit:
	ld a,"S"
	ld [$a000],a
	ld a,"B"
	ld [$a001],a
	ld a,"K"
	ld [$a002],a
	ld a,4
	ld [$a003],a
.skipraminit:
	ld a,[$a003]
	cp 4
	jp z,.changeto2
	cp 5
	jp z,.changeto1
	jp .loadsplashvarin
.changeto1:
	ld a,4
	jp .loadsplashvarin
.changeto2:
	ld a,5
	jp .loadsplashvarin
.loadsplashvarin:
	ld [$a003],a
	ld a,4
	ld [_SplashScreen],a
	
	xor  a
	ld   [0],a    ; Disable Cart Save RAM to prevent
                ; false writes during powerdown
    ret

; Write B to Cart RAM location HL
; (HL needs to be in range $a000-$bfff.)

WriteToCartRAM:
	ld   a,$0a
	ld   [0],a    ; Enable Cart Save RAM

	ld   [hl],b

	xor  a
	ld   [0],a    ; Disable Cart Save RAM to prevent
                ; false writes during powerdown
	ret

; Read Cart RAM location HL into B
; (HL needs to be in range $a000-$bfff.)

ReadFromCartRAM:
	ld   a,$0a
	ld   [0],a    ; Enable Cart Save RAM

	ld   b,[hl]

	xor  a
	ld   [0],a    ; Disable Cart Save RAM to prevent
                ; false writes during powerdown
	ret

		
; HI-Init
db "Beginning of HI_Init"

HI_Init:
	call ENABLE_RAM_MBC1
	
	ld hl,$A003
	call ReadFromCartRAM
	ld a,b
	call SWITCH_ROM_MBC1
	
;	ld      hl,GBPalette
;	ld      de,GBPalette1
;	ld      bc,1200         ; length (8 bytes per tile) x (256 tiles)
;	call    mem_Copy	    ; Copy tile data to memory
			ld 		a,$01
		ld		[himode],a
	ld hl,$A003
	call ReadFromCartRAM
	ld a,b

	
	call Initialise
	call	DoubleSpeed

	ld      hl,GBPalette
	ld      de,GBPalette1
	ld      bc,$1200         ; length (8 bytes per tile) x (256 tiles)
	call    mem_Copy	    ; Copy tile data to memory
			ld 		a,$01
		ld		[himode],a
	ld hl,$A003
	call ReadFromCartRAM
	ld a,b
	
	call	DisplayPicture
.wait:
	;call    WaitVBL
	;call	UpdateHiPals
	call	ReadJoystick
	ld		a,[_PadDebounce]
	ld b,a
	ld		a,[_Pad]
	and b
	cp 8
	jr nz,.wait
	ld a,$02
	ld [himode],a
	;jp afterthestart
	;jr .overstring
	ret

ReadJoystick:

	ld		a,P1F_5
	ld		[rP1],a        ;turn on P15

	ld		a,[rP1]        ;delay
	ld		a,[rP1]
	ld		a,[rP1]
	ld		a,[rP1]
	cpl
	and     $0f
	swap	a
	ld		b,a

	ld      a,P1F_4
	ld      [rP1],a     ;turn on P14
	ld      a,[rP1]     ;delay
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	ld      a,[rP1]
	cpl
	and     $0f
	or		b
	ld      b,a

	ld		a,[_Pad]
	xor		b
	and		b
	ld		[_PadDebounce],a
	ld		a,b
	ld		[_Pad],a

	ld		a,P1F_5|P1F_4
	ld      [rP1],a

	ret

	
;***************************************************************************
;*
;* pad_Read - Read the joypad
;*
;* output:
;*   _PadData & A     - joypad matrix
;*   _PadDataEdge & B - edge data: which buttons were pressed since last time
;*                       this routine was called
;*
;***************************************************************************
pad_Read::
        ld      a,P1F_5
        ld      [rP1],a        ;turn on P15

        ld      a,[rP1]        ;delay
        ld      a,[rP1]
	cpl
        and     $0f
	swap	a
	ld	b,a

        ld      a,P1F_4
        ld      [rP1],a     ;turn on P14
        ld      a,[rP1]     ;delay
        ld      a,[rP1]
        ld      a,[rP1]
        ld      a,[rP1]
        ld      a,[rP1]
        ld      a,[rP1]
	cpl
        and     $0f
	or	b
        ld      b,a

	ld	a,[_PadData]
	xor	a,b
	and	a,b
	ld	[_PadDataEdge],a
	ld	a,b
	ld	[_PadData],a
        push    af

	ld	a,P1F_5|P1F_4
        ld      [rP1],a

        ld      a,[_PadDataEdge]
        ld      b,a
        pop     af
	ret

DisplayPicture:

	ld		[$2000],a			; Switch to relevant bank

	call	ScreenOff			; Turn off the screen so we can write characters

	xor		a					; Switch to character bank 0
	ld		[rVBK],a

	ld		de,$8800			; Address for BG characters
	ld		bc, 16 * 256		; Transfer 256 characters

	ld		a,[$4000]			; Get address of where characters stored
	ld		l,a
	ld		a,[$4001]

	ld		h,a	
	call	TransferCharData	; Transfer characters

	ld		a,1					; Switch to alternate character bank
	ld		[rVBK],a

	ld		de,$8800
	ld		bc, 16 * 104		; Transfer 104 characters

	call	TransferCharData

	ld		hl,$9800			; Screen Address (attributes)
	ld		a,[$4002]
	ld		c,a
	ld		a,[$4003]
	ld		b,a					; BC = Attribute memory

	call	WriteScreen			; Transfer character attributesWriteScreen:

	xor		a
	ld		[rVBK],a

	ld		hl,$9800
	ld		a,[$4004]
	ld		c,a
	ld		a,[$4005]
	ld		b,a					; BC = Map memory

	call	WriteScreen

	ld		a, LCDCF_ON | LCDCF_OBJON | LCDCF_BGON | LCDCF_WIN9800                ; LCD Controller = On
	call	ScreenOnVB

	ret


UpdateHiPals:

	ld a,1
	call SWITCH_RAM_MBC1
	ld		hl,GBPalette1		;point HL to palette data.
	ld sp,hl
	
	xor		a
	ld		[$a005],a        		;
	
._palloop:
	inc de
	
	pop de
	inc		d
	inc		e
	push de
	pop de

	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	pop de
	inc		d
	inc		e
	push de
	pop de
	
	ld		a,[$a005]        		;
	inc 	a
	ld		[$a005],a        		;
	cp		142					;test for bottom of image.
	jp		nz,._palloop			;
	ret






DoubleSpeed::

	di
	ld		hl,rIE
	ld		a,[hl]
	push	af

	xor		a
	ld		[hl],a
	ld		[rIF],a

	ld		a,$30
	ld		[rP1],a

	ld		a,1
	ld		[rKEY1],a

	stop

	pop		af
	ld		[hl],a
	ei
	ret


Initialise:

	di

.init_WaitVBL:

	ldh		a,[rLY]					; $ff44=LCDC Y-Pos
	cp		$90						; $90 and bigger = in VBL
	jr		c,.init_WaitVBL			; Loop until it is $90 or >

	ld		a,LCDCF_OFF
	ld		[rLCDC],a               ; Turn screen off for memory copy


	xor		a						; Clear all of RAM 
	ld		hl,$C000
	ld		bc,$2000
	call	mem_Set
	
	ld [Sprite_oam],a
	ld [spbak],a
	ld [spbak + 1],a
	xor a
	
	xor		a
	ld		[rIF],a				; Interrupt request RESET
	ld		[rSTAT],A			; LCDC status information RESET
	ld		[rSCX],a			; Scroll X register RESET
	ld		[rSCY],a			; Scroll Y register RESET
	ld		[rWY],a
	ld		a,7
	ld		[rWX],a

; Color Specific Reset Code

	xor		a
	ld		[rVBK],a			; VramBank=0
	ld		[rSVBK],a			; WorkRamBank=0
	ld		[rRP],a				; Infrared communication port (CLEAR to save power

	inc		a
	ld		[rVBK],a			; Switch to VRAM Bank 1

	xor		a					; Clear all of VRAM (Bank 1)
	ld		hl,$8000
	ld		bc,$2000
	call	mem_Set

	xor		a
	ld		[rVBK],a			; Switch to VRAM Bank 0

	ld		hl,$8000
	ld		bc,$2000
	call	mem_Set

	ld		hl, _OAMRAM                     ; Sprite Attribute Area
	ld		a,$a0				; Number of bytes to clear


.init_ClearSprites:

	ld		[hl],0            		; Transfer byte to VRAM
	inc		hl

	dec		a                  		; decrement counter
	or		a                  		; or with c. Check to see if both are zero
	jr		nz, .init_ClearSprites

	ld		hl, OAM_LOCATION
	ld		a, $a0


.init_ClearSpriteMem:

	ld		[hl],0		   	; Transfer byte to VRAM
	inc		hl

	dec		a				; decrement counter
	or		a				; or with c. Check to see if both are zero
	jr		nz, .init_ClearSpriteMem

; Copy the sprite routine into high ram

	ld		hl,SPRITE_ROUTINE
	ld		de,SpriteRoutine
	ld		b,SpriteRoutineEnd-SpriteRoutine

init_RoutineLoop:

	ld		a,[de]
	ld		[hl],a			; Transfer byte to SPRITE_ROUTINE

	inc		de
	inc		hl

	ld		a,b
	dec		a				; decrement counter
	or		a				; or with a. Check to see if both are zero
	ld		b, a

	jr		nz, init_RoutineLoop		; If not zero repeat

	ei
	ret

; Routine that is transfered to SPRITE_ROUTINE

SpriteRoutine:

	push	af
	push	hl

	ld		hl,OAM_LOCATION
	ld		a,h
	ldh		[rDMA], a

	ld		a, $28

Wait:

	dec		a
	jr		nz, Wait

	pop		hl
	pop		af

	ret

SpriteRoutineEnd:










; ********************************************************
; Transfers CharData to VRAM
; Load DE with the VRAM address
; Load HL with address of the char data
; Load BC with the bytes to transfer
; ********************************************************

TransferCharData::

	push	af

CharLoop:

	ld		a,[hli]            ; Load char data
	ld		[de], a
	inc		de                 ; increment memory location
	dec		bc                 ; decrement counter
	ld		a, b               ; transfer upper byte of counter to a
	or		c                  ; or with c. Check to see if both are zero
	jr		nz, CharLoop       ; If not zero repeat

	pop  	af

	ret



; ********************************************************
; Turn Screen off
; Load A with value for 0xff41
; ********************************************************

ScreenOff::

	push	bc
	ld		b,a
	ld		a,[rLCDC]
	bit		7,a
	jr		z,.scfin

	di

.ScOff:

	ld   	a, [rLY]
	cp   	$90
	jr   	nz,.ScOff
	
	xor		a
	ld   	[rLCDC], a
	ei

.scfin

	ld		a,b
	pop		bc

	ret


VBLANK:

	push	af
	push	bc
	push	de
	push	hl


	pop		hl
	pop		de
	pop		bc
	pop		af
	reti


; ********************************************************
; Turn Screen on with Vertical Blanking interrupts
; Load A with value for 0xff41
; ********************************************************

ScreenOnVB::

	push	af

	ld		[rLCDC],a

.loop

	ld		a,[rLY]
	cp		144
	jr		c,.loop


	ld		a,[rSTAT]
	or		STATF_BUSY
	ld		[rSTAT], a

	ld		a,[rIF]
	or		IEF_VBLANK
	ld		[rIF], a

	ld		a,IEF_VBLANK|IEF_TIMER
	ld		[rIE], a

	pop		af

	ret


WriteScreen:

	ld		a,18

.yloop
	
	ld		e,20
	push	af

.xloop

	ld		a,[bc]
	inc		bc
	ld		[hli],a
	dec		e
	jr		nz,.xloop
	ld		de,12
	add		hl,de
	pop		af
	dec		a
	jr		nz,.yloop
	ret



;***********************************************
;* VBlank Interrupt routine for Hicol Software *
;***********************************************
vbl:
	push af
	ld		a,[himode]
	cp $02
	jp c,.hicolor_vbl
	pop af
	ret
	
.hicolor_vbl:
	pop af
	ld		[spbak],sp			;store SP.

	ld		a,1
	ld		[rVBK],a

	ld		hl,GBPalette1		;point SP to palette data.
	ld		sp,hl				;

	ld		a,$80				;
	ld		hl,rBCPS			;setup palette write.
	ld		[hl],a				;


	ld		hl,rLY         		;
	xor		a

._wait:			

	cp		[HL] 				;
	jr		nz,._wait

._palloop:

	pop		de            		;get 2 palette values.

	ld		l,rSTAT & 255		;point HL to STAT.

._waitstat2:

	bit		1,[hl]				;wait for HBlank.
	jr		nz,._waitstat2 		;

.fti:

	ld		l,rBCPD & 255

	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de					;
	ld		[hl],e				;
	ld		[hl],d	

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d

	pop		de            		;get 2 palette values.
	ld		[hl],e        		;
	ld		[hl],d        		;write 2 palette values.

	pop		de
	ld		[hl],e				;
	ld		[hl],d


	ld		a,[rLY]        		;
	cp		142					;test for bottom of image.
	jr		nz,._palloop			;

	ld		hl,spbak
	ld		a,[hli]       		;
	ld		h,[hl]				;restore SP.
	ld		l,a					;
	ld		sp,hl
	
	;call UpdateHiPals
	ret
; _____  _________   ___ ________ _   _____   _   ___ ____________   
;  | ||\/||___|__/   |  \|[__ |__]|   |__| \_/    |__]|__/|  ||      
;  | ||  ||___|  \   |__/|___]|   |___|  |  |     |   |  \|__||___   
;                                                                    

UpdateTimeRemaining:

call Timer

ld a, [_TimeRemaining]

call Cnvt
call WaitVBL

ld a,b
add 14
ld [$9800 + 7 + 32],a

ld a,c
add 14
ld [$9800 + 8 + 32],a

ret


; ___ _   ____________   _  ______   _  _____ 
; |__]|   |__||   |___   |  ||__||   |  ||___ 
; |   |___|  ||___|___    \/ |  ||___|__||___ 
;                                            
; _________  __  ____________________   
; |   |  ||\ ||  ||___|__/ | |  ||__/   
; |___|__|| \| \/ |___|  \ | |__||  \   
;                                      
; by Jeff Frohwein
;
; A = Input number
; B = tens
; C = ones

Cnvt:
        ld      b,-1
        ld      d,-10
.loop:  ld      c,a
        inc     b
        add     a,d
        jr      c,.loop
        ret
        
        
; _____  _________   _  ______   ___ ________   ___ ____________   
;  | ||\/||___|__/   |__||___|   |__]|___|__/   |__]|__/|  ||      
;  | ||  ||___|  \   |  ||___|___|   |___|  \   |   |  \|__||___   
                                                                 


; Timer Function
; Updates Timer and also TimeRemaining if necessary.

Timer:
		; First order of business: Is the timer zero yet?
		; Get ready, don't destroy anything!
		push	af
		; Get the timer ready!
		ld		a, [_Timer]
		; Compare it
		cp		0
		; Skip or no skip?
		jp		nz,.skipreset
		; OK, no skip...
		; Reset the timer
		ld		a, TimePerSecond
		ld		[_Timer], a
		ld		a, [_TimeRemaining]
		cp		0
		jp 		nz,.minustr
		ld		a, AmountofTime
		ld		[_TimeRemaining], a
		jp		.endsub
.minustr:
		sub 1
		ld		[_TimeRemaining], a
		jp		.endsub
.skipreset:
		ld		a, [_Timer]
		sub 1
		ld		[_Timer], a
		jp .endsub
.endsub:
		pop af
		ret

Correct:
		ld a,6
		call SWITCH_ROM_MBC1
;		call WaitVBL
		call WaitVBL
		
		ld 		a,$01
        ld		[$FF4F],a
        
        push af
		call WaitVBL
		pop af
        ld      hl,CorrectMapPLN1;Draw title
        ld      de,$9C00
        ld      bc,2*32 + 20
        call    mem_CopyVRAM
        
        call WaitVBL
        ld 		a,$00
        ld		[$FF4F],a
		call WaitVBL
        ld      hl,CorrectMapPLN0;Draw title
        ld      de,$9C00
        ld      bc,2*32 + 20
        call    mem_CopyVRAM
        call winscrl
        
 		ld a, [_CustRemaining]
 		dec a
 		ld [_CustRemaining],a
 		
		call Cnvt
		
		
		
		ld a,b
		add 14
		push af
		call WaitVBL
		pop af
		ld [$9800 + 7 + 64],a
		
		ld a,c
		add 14
		push af
		call WaitVBL
		pop af
		ld [$9800 + 8 + 64],a
		
		ld a,1
		call SWITCH_ROM_MBC1
		call ChangeCustomer
        ret
winscrl:
         call WaitVBL 
         call WaitVBL
 		ld a,8
        ld [rWX],a        
        ld a,144
        ld [rWY],a
.aloop:
 		call WaitVBL
        call WaitVBL
        call WaitVBL
        call WaitVBL
        ld a,[rWY]
        dec a
        ld [rWY],a
 		cp 124
 		jp nz,.aloop
		ld a,0
.sitthereloop:
		ld b,a
		call WaitVBL
		ld a,b
		inc a
		cp 254
		jp nz,.sitthereloop
		ld a,0
.sitthereloop2:
		ld b,a
		call WaitVBL
		ld a,b
		inc a
		cp 100
		jp nz,.sitthereloop2
.bloop:
 		call WaitVBL
        call WaitVBL
        call WaitVBL
        call WaitVBL
        ld a,[rWY]
        inc a
        ld [rWY],a
 		cp 145
 		jp c,.bloop
		ret
Incorrect:
		ld a,6
		call SWITCH_ROM_MBC1
		call WaitVBL
		call WaitVBL
		
		ld 		a,$01
        ld		[$FF4F],a
        
        ld      hl,IncorrectMapPLN1;Draw title
        ld      de,$9C00
        ld      bc,3*32
        call    mem_CopyVRAM
        
        call WaitVBL
        ld 		a,$00
        ld		[$FF4F],a

        ld      hl,IncorrectMapPLN0;Draw title
        ld      de,$9C00
        ld      bc,3*32
        call    mem_CopyVRAM
		call winscrl
		ret

;  ______   ____ _______    ___ ____________   
;  ||  | \_/ |__]|__||  \   |__]|__/|  ||      
; _||__|  |  |   |  ||__/   |   |  \|__||___   
;                                             
                                             
joypad:
		call pad_Read
		bit 0,a
		jp nz,.a
		bit 1,a
		jp nz,.b
		bit 2,a
		jp nz,.select
		bit 3,a
		jp nz,.start
		bit 4,a
		jp nz,.right
		bit 5,a
		jp nz,.left
		bit 6,a
		jp nz,.up
		bit 7,a
		jp nz,.down
		ret
.a:
		ld a,5
		call IsCorrect
		;call Correct
		ret
.b:
		ld a,4
		call IsCorrect
		;call Incorrect
		ret
.start:
		ld a,1
		call SWITCH_ROM_MBC1
		call ChangeCustomer
		ret
.select:
		ret
.left:
		ld a,1
		call IsCorrect
		ret
.right:
		ld a,3
		call IsCorrect
		ret
.up:
		ld a,0
		call IsCorrect
		ret
.down:
		ld a,2
		call IsCorrect
		ret

IsCorrect:
		ld b,a
		jp .str
		db "ABCD"
.str:
		
		ld a,[_CurOrder]
		cp b
		jp z,Correct
		jp nz,Incorrect
		ret
		ret
		ret
		

; _ _ _________   ____________   _  ____ _      ___ ____________   
; | | ||__|| |    |___|  ||__/   |  ||__]|      |__]|__/|  ||      
; |_|_||  || |    |   |__||  \    \/ |__]|___   |   |  \|__||___   
;                                                                 
		
WaitVBL:
        ld      a,[rLY]
        cp      0               ; Is display on scan line 145 yet?
        jp      nz,WaitVBL      ; no, keep waiting
        ret

; _____________________  _   ____________   ___ ____________   
; [__ |   |__/|___|___|\ |   |  ||___|___   |__]|__/|  ||      
; ___]|___|  \|___|___| \|   |__||   |      |   |  \|__||___   
;                                                              

StopLCD:
        ld      a,[rLCDC]
        rlca                    ; Put the high bit of LCDC into the Carry flag
        ret     nc              ; Screen is off already. Exit.

; Loop until we are in VBlank

.wait:
        ld      a,[rLY]
        cp      145             ; Is display on scan line 145 yet?
        jr      nz,.wait        ; no, keep waiting

; Turn off the LCD

        ld      a,[rLCDC]
        res     7,a             ; Reset bit 7 of LCDC
        ld      [rLCDC],a

        ret


;____ ____ _  _   / ____ ____ _  _    ___  ____ ____ ____ ____ 
;|__/ |__| |\/|  /  |__/ |  | |\/|    |__] |__/ |  | |    [__  
;|  \ |  | |  | /   |  \ |__| |  |    |    |  \ |__| |___ ___] 
;                                                              

        
SWITCH_ROM_MBC1:
  ld [$2000],a
  ret

SWITCH_RAM_MBC1:
  ld [$4000],a
  ret

ENABLE_RAM_MBC1:
  push af
  ld a,$0A
  ld [$0000],a
  pop af
  ret
  
DISABLE_RAM_MBC1:
  push af
  ld a,$00
  ld [$0000],a
  pop af
  ret

;a=b*c
Multiply:
	xor a
.loop:
	push af
	ld a,c
	cp 0
	jp z,.out
	pop af
	add a,b
	dec c
	jp .loop
.out:
	pop af
	ret
	
; _  _________________ _   ________   
; |  ||__||__/||__||__]|   |___[__    
;  \/ |  ||  \||  ||__]|___|______]   
                                    

SECTION "InternalVars",BSS
_Timer:: 			DS 1		;holds time until next second
_TimeRemaining:: 	DS 1		;starts out $14 (20 decimal), holds time remaining
_CustRemaining::	DS 1		;How many customers are left?
_CurHead::			DS 1		;which customer's head is on?
_CurBody::			DS 1		;which shirt is on?
_CurOrder::			DS 1		;what did the customer order?
_CurLevel::			DS 1		;what level are we playing?
_CurCustomer::		DS 1		;who's the current customer?
_SplashScreen::		DS 1
AmountOfBodies		EQU 4
AmountOfHeads		EQU 4
AmountOfCustomers	EQU 6
Sprite_oam	 		ds	$A0			; Sprite Data Area ** THIS VARIABLE CAN NOT BE MOVED **
CGBFlag		 		db				; Is it a Color gameboy?
_PadData			db
_PadDataEdge		db
_Pad				db
_PadDebounce		db
spbak				dw
himode				db
GBPalette1			ds $1200

SECTION "WhichTiles",CODE[$4000],BANK[1]

BodyTiles:
	DB 25, 55, 57, 59
	
HeadTiles:
	DB 26, 56, 58, 60
	
OrderTiles:
	DB 41, 42, 43, 44, 45, 46
	
OrderPals:
	DB 3, 6, 0, 1, 0, 5

Customers:
;   DB Head, Body, Order
	DB 1, 1, 0
	DB 3, 0, 1
	DB 0, 3, 2
	DB 2, 2, 3
	DB 3, 3, 4
	DB 0, 0, 5
	db 3,2,2
	
GameData:
;	DB NumberOfCustomers, AmountOfTime, TableLocation
	DB 7, 20, Customers

	DB $00, $FF, $00, $FF
	DB "SimBurgerKing is (C)2000 JoshuaWise.COM Enterprises. Built for Y2Kode 2000 by Lik-Sang."

ChangeCustomer:
;		; Customer is at [$9800 + 34 + 32]
		ld 			a,[_CurLevel]
		ld 			b,a		
		ld 			a,3
		ld 			c,a
		call 			Multiply
		ld			c,a
		xor 			a
		ld 			b,a
		ld			hl,GameData
		;add			bc
		;ld			hl,bc
		ld			a,[hl]
		ld			b,a
		ld 			a,[_CurCustomer]
		add			3  
		cp 			b
		jp 			nz,.updateCustomer
.ResCustomer:
		ld			a,0
.updateCustomer:
		;head
		ld			[_CurCustomer],a
		AddMacro 	[_CurCustomer],Customers
		ld a,[hl]
		ld [_CurHead],a
		AddMacro	[_CurHead],HeadTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld [$9800 + 34], a
		
		;body		
		ld			a,[_CurCustomer]
		add			1
		AddMacro 	a,Customers
		ld a,[hl]
		ld [_CurBody],a
		AddMacro	[_CurBody],BodyTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld [$9800 + 34 + 32], a
		ld [_CurBody], a
		
		;order
		ld			a,[_CurCustomer]
		add 2
		AddMacro 	a,Customers
		ld a,[hl]
		ld [_CurOrder],a
		AddMacro	a,OrderPals
		push af
		call		WaitVBL
		lcd_WaitVRAM
		ld a,1
		ld [rVBK],a
		pop af
		ld a,[hl]
		ld [$9800 + (32 * 4) + 7], a
		ld a,0
		ld [rVBK],a

		ld			a,[_CurCustomer]
		add 2
		AddMacro 	a,Customers
		ld a,[hl]
		AddMacro	a,OrderTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		
		pop af
		ld a,[hl]
		ld [$9800 + (32 * 4) + 7], a
		
		ret


ChangeBody:
;		; body is at [$9800 + 34 + 32]
		ld 			a,[_CurBody]
		add			1
		cp 			4
		jp 			z,.ResBody
		jp .updatebody
.ResBody:
		ld			a,0
.updatebody:
		ld			[_CurBody],a
		AddMacro 	[_CurBody],BodyTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + 34 + 32], a
		ret
		
ChangeOrder:
;		; body is at [$9800 + 34 + 32]
		ld 			a,[_CurOrder]
		add			1
		cp 			4
		jp 			z,.ResOrder
		jp .updateorder
.ResOrder:
		ld			a,0
.updateorder:
		ld			[_CurOrder],a
		AddMacro 	[_CurOrder],OrderTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + (32 * 4) + 7], a
		ret

ChangeHead:
;		; Head is at [$9800 + 34 + 32]
		ld 			a,[_CurHead]
		add			1
		cp 			4
		jp 			z,.ResHead
		jp .updateHead
.ResHead:
		ld			a,0
.updateHead:
		ld			[_CurHead],a
		AddMacro 	[_CurHead],HeadTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + 34], a
		ret
		
music:          incbin "musicbox.sav"      ; the music as binary data
	
; ___ _  _____   ___ _____   ______________   ___ ________________   
; |__]|_/ | __   |__]|__||   |___ |  | |___   |__]|__/|  ||   [__    
; |__]| \_|__]   |   |  ||___|___ |  | |___   |   |  \|__||______]   
; 

SECTION "Palette Functions",CODE[$4000],BANK[3]
                                                                   
SetSingleCGB_BGP:
        add     a,a             ; a = pal # * 2
        add     a,a             ; a = pal # * 4
        add     a,a             ; a = pal # * 8
        add     a,$80
        ld      [$FF68],a

        ld      bc,$0869        ; b = 8, c = rBCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set all background palettes ***
; Entry: HL = pntr to data for 8 palettes

SetAllCGB_BGP:
        ld      a,$80
        ld      [$FF68],a

        ld      bc,$4069        ; b = 64, c = rBCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set a single object (sprite) palette ***
; Entry: HL = pntr to data for 1 palette
;         A = palette number (0-7)

SetSingleCGB_OBJP:
        add     a,a             ; a = pal # * 2
        add     a,a             ; a = pal # * 4
        add     a,a             ; a = pal # * 8
        add     a,$80
        ld      [$FF6A],a

        ld      bc,$086b        ; b = 8, c = rOCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set all object (sprite) palettes ***
; Entry: HL = pntr to data for 8 palettes

SetAllCGB_OBJP:

        ld      a,$80
        ld      [$FF6A],a

        ld      bc,$406b        ; b = 64, c = rOCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

;  This RGBSet Macro uses RGB values from 0 to 255.
; Even though this is a greater color range than the
; GBC supports it allows you to directly read color
; values from your favorite paint program using the
; eye dropper tool and drop them directly into your
; program.


RGBSet: MACRO
        DW      ((\3 >> 3) << 10) + ((\2 >> 3) << 5) + (\1 >> 3)
        ENDM
        
;Old Data
;		cp			0
;		jr			z,.Body0
;		cp			1
;		jr			z,.Body1
;		cp			2
;		jr			z,.Body2
;		cp			3
;		jr			z,.Body3
;.Body0:
;		ld			a,[BodyTiles + 0]
;		jp			.loaditin
;.Body1:
;		ld			a,[BodyTiles + 1]
;		jp			.loaditin
;.Body2:
;		ld			a,[BodyTiles + 2]
;		jp			.loaditin
;.Body3:
;		ld			a,[BodyTiles + 3]
;		jp			.loaditin
;.loaditin:

SECTION "Hi-Color Funcs",DATA,BANK[4]
	dw	GBCharacters1
	dw	GBAttributes1
	dw	GBMap1
	dw	GBPalette

GBCharacters1:

        incbin  "TEST.TIL"                              ; 20 x 18 x 16 = 5760

GBAttributes1:						; 20 x 18 = 360

        incbin  "TEST.ATR"

GBMap1:								; 20 x 18 = 360

        incbin  "TEST.MAP"

GBPalette:

        incbin  "TEST.PAL"                              ; 72 * 8 * 4 * 2 = 4608

SECTION "Hi-Color Funcs(Mike)",DATA,BANK[5]
	dw	GBCharacters2
	dw	GBAttributes2
	dw	GBMap2
	dw	GBPalette2

GBCharacters2:

        incbin  "MIKE.TIL"                              ; 20 x 18 x 16 = 5760

GBAttributes2:						; 20 x 18 = 360

        incbin  "MIKE.ATR"

GBMap2:								; 20 x 18 = 360

        incbin  "MIKE.MAP"

GBPalette2:

        incbin  "MIKE.PAL"                              ; 72 * 8 * 4 * 2 = 4608

